<template>
  <div id="universes" class="universe-tab">
    <div class="tab-action">
      <div class="ctl-tabs">
        <div class="ctl-tabs-wrapper">
          <div
            v-for="(item, index) of tabs"
            :key="`tab-${index}`"
            class="tab"
            :class="{ active: item === activeKey }"
            @click="setSelected(item)"
          >
            {{ getTabName(item) }}
          </div>
        </div>
      </div>
      <div class="ctl-sort">
        <div class="only-mobile" @click="displayModal = true">
          <img
            class="sort-btn"
            :src="require('~/assets/images/bt-sort-default.svg')"
          />
        </div>

        <div class="sort only-desktop">
          <multiselect
            v-model="currentFilter"
            :searchable="false"
            :allow-empty="false"
            label="label"
            track-by="value"
            :options="extendedFilters"
            :show-labels="false"
          ></multiselect>
        </div>

        <AppModal
          v-if="displayModal"
          :no-default="true"
          :closing-cross="true"
          :full-width="true"
          @close="displayModal = false"
        >
          <template v-slot:body>
            <div class="modal-filters">
              <div
                v-for="(item, index) of filters"
                :key="`filter-${index}`"
                :class="{
                  active: item.value === currentFilter.value,
                  default: item.value === 'default'
                }"
                @click="setFilter(item)"
              >
                {{ $t(item.label) }}
              </div>
            </div>
          </template>
        </AppModal>
      </div>
    </div>

    <Loader :display="isLoading" />

    <div v-if="displayedList.length" class="universe-list">
      <UniverseListItem
        v-for="(item, idx) in displayedList"
        :key="`universe-${idx}`"
        :universe="item"
      />
      <UniverseListItemEmpty v-for="item in emptyList" :key="`empty-${item}`" />
    </div>

    <Pagination
      v-if="activeTabCount > paginationLimit"
      :current-page="currentPage"
      :total-page="activeTabTotalPage"
      :items-per-page="paginationLimit"
      @updatePage="updatePage"
    />
  </div>
</template>

<script>
import Loader from '~/components/ui/Loader'
import AppModal from '~/components/ui/AppModal'
import Pagination from '~/components/ui/Pagination'
import UniverseListItem from '~/components/UniverseList/UniverseListItem'
import UniverseListItemEmpty from '~/components/UniverseList/UniverseListItemEmpty'

export default {
  components: {
    Loader,
    AppModal,
    Pagination,
    UniverseListItem,
    UniverseListItemEmpty
  },
  props: {
    tabList: {
      type: Array,
      required: true
    }
  },
  data() {
    return {
      isLoading: true,

      activeKey: 'all',

      filters: [
        { label: this.$t('catalog.sort_new'), value: 'new' },
        { label: this.$t('catalog.sort_old'), value: 'old' },
        { label: this.$t('catalog.sort_alpha'), value: 'a-z' },
        { label: this.$t('catalog.sort_alpha_desc'), value: 'z-a' }
      ],

      displayModal: false,
      currentFilter: undefined,

      universes: [],
      displayedList: [],

      currentPage: 1,
      paginationLimit: 9
    }
  },

  computed: {
    tabs() {
      return this.tabList.map((v) => v.key)
    },

    activeTabCount() {
      return this.tabCount(this.activeKey)
    },

    activeTabTotalPage() {
      return Math.ceil(this.tabCount(this.activeKey) / this.paginationLimit)
    },

    extendedFilters() {
      return [
        { label: this.$t('catalog.sort'), value: null, $isDisabled: true }
      ].concat(this.filters)
    },

    emptyList() {
      const array = []

      if (this.displayedList.length && this.displayedList.length % 3) {
        for (let i = this.displayedList.length % 3; i < 3; i++) {
          array.push(i)
        }
      }

      return array
    }
  },

  watch: {
    currentFilter: function () {
      this.resetTabs()
    }
  },

  mounted() {
    this.currentFilter = this.filters[0]
  },

  methods: {
    resetAllPages() {
      this.tabList.forEach((tabObj) => {
        if (this.universes[tabObj.key]) this.universes[tabObj.key].pages = []
      })
    },

    async resetTabs() {
      this.resetAllPages()
      await this.loadUniverses(this.activeKey, 1)
      this.currentPage = 1
    },

    setFilter(filter) {
      this.currentFilter = filter
      this.displayModal = false
    },

    setSelected(key) {
      this.activeKey = key
      this.loadUniverses(this.activeKey, 1)
      this.currentPage = 1
    },
    getTabName(key) {
      const shelf = this.tabList.find((v) => v.key === key)
      if (shelf.key === 'all') return this.$t('common.all_shelves')
      else return shelf.name
    },
    getTabId(key) {
      const shelf = this.tabList.find((v) => v.key === key)
      if (!shelf.id) return 0
      else return shelf.id
    },
    async updatePage(currentPage) {
      await this.loadUniverses(this.activeKey, currentPage)
      this.currentPage = currentPage

      const top = document.getElementById('universes').offsetTop
      window.scrollTo(0, top)
    },
    tabCount(key) {
      return this.tabList.find((v) => v.key === key).count
    },

    async loadUniverses(type, page) {
      if (!type) return

      try {
        if (!this.universes[type] || !this.universes[type].pages[page - 1]) {
          if (!this.universes[type]) this.universes[type] = { pages: [] }

          const sort = this.currentFilter.value

          const items = await this.$api.universeList(
            this.getTabId(type),
            sort,
            (page - 1) * this.paginationLimit,
            this.paginationLimit,
            this.$utils.aboArea()
          )
          this.universes[type].pages[page - 1] = items.items
        }

        this.displayedList = this.universes[type].pages[page - 1]
      } finally {
        this.isLoading = false
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.tab-action {
  position: relative;
  padding: 1rem 0;

  width: 100%;
  height: 100%;

  &:after {
    content: '';
    position: absolute;
    top: 0;
    bottom: 0px;
    right: 30px;
    z-index: 1;
    pointer-events: none;
    background-image: linear-gradient(
      to right,
      rgba(255, 255, 255, 0),
      white 65%
    );
    width: 7%;
  }

  .ctl-tabs {
    margin-right: 40px;

    .ctl-tabs-wrapper {
      display: flex;
      white-space: nowrap;

      @media (max-width: 768px) {
        border-bottom: 1px solid #ededed;
        overflow-x: scroll;
        scrollbar-width: none;
        -ms-overflow-style: none;
      }
    }

    .tab {
      cursor: pointer;
      margin-right: 2rem;
      padding: 0.5rem;
      padding-bottom: 0.75rem;
      white-space: nowrap;

      &:hover,
      &.active {
        color: $color-secondary;
        border-bottom: 5px solid $color-secondary;
      }

      @media (max-width: 768px) {
        margin-right: 0.75rem;
        font-size: 14px;
        padding: 0.25rem;
        padding-bottom: 0.5rem;
      }
    }
  }

  .ctl-sort {
    position: absolute;
    top: 10px;
    right: 5px;

    .sort-btn {
      min-width: 32px;
      min-height: 32px;
    }
    @media (max-width: 768px) {
      flex: inherit;
    }
  }

  .sort-select {
    background: white;
  }

  .modal-filters {
    div {
      cursor: pointer;
      margin: 1.5rem 0;
    }

    .active {
      font-weight: bold;
    }

    .default {
      color: #808080;
    }
  }

  .only-mobile {
    display: none;
  }

  .only-desktop {
    display: inline-block;
  }

  @media (max-width: 768px) {
    .only-mobile {
      display: block;

      &.sort-btn {
        display: inline-block;
      }
    }

    .only-desktop {
      display: none;
    }
  }
}

.universe-list {
  display: flex;
  flex-wrap: wrap;
  justify-content: space-between;
  margin-bottom: 71px;
  margin-top: 20px;

  @media (max-width: 768px) {
    justify-content: center;
  }
}
</style>

<style lang="scss">
.ctl-sort {
  .multiselect {
    &__content-wrapper {
      border: none;
      box-shadow: 0 0 8px 0 rgba(0, 0, 0, 0.25);
    }

    &__tags {
      border: 0;
      min-width: 200px;
    }

    &__option--disabled {
      color: #999 !important;
      background: #fff !important;
    }

    &__option--selected {
      background: #fff !important;
    }

    &__option--highlight {
      background-color: #5897fb !important;
    }
  }
}
</style>
